/*
 *  TOPPERS Software
 *      Toyohashi Open Platform for Embedded Real-Time Systems
 * 
 *  Copyright (C) 2007,2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 * 
 *  L쌠҂́Cȉ(1)`(4)̏𖞂ꍇɌC{\tgEF
 *  Ai{\tgEFAς̂܂ށDȉjgpEE
 *  ρEĔzziȉCpƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 *      ܂C{\tgEFÃ[U܂̓Gh[ÛȂ闝
 *      RɊÂCL쌠҂TOPPERSvWFNg
 *      Ɛӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̎gpړI
 *  ɑ΂K܂߂āCȂۏ؂sȂD܂C{\tgEF
 *  A̗pɂ蒼ړI܂͊ԐړIɐȂ鑹QɊւĂC
 *  ̐ӔC𕉂ȂD
 * 
 *  @(#) $Id: test_cpuexc5.c 818 2008-03-18 12:56:15Z hiro $
 */

/* 
 *		CPUÕeXg(5)
 *
 * yeXg̖ړIz
 *
 *  ^XNReLXgCbNCCPUbNԂŔCPUO
 *  ɂVXeԂ̃eXgDݗDx}XNTIPM_ENAALLCfB
 *  Xpb`֎~ԁC^XNOԂŃeXgD
 *
 * yeXgځz
 *
 *  C^XNReLXgCbNCCPUbNԂŔ
 *  CPUOɂāC
 *
 *	(A) CPUOnhsJnCPUbNtOωȂ
 *	(B) CPUOnhsJnɊݗDx}XNωȂ
 *		ICPUOnhŊݗDx}XNǂ߂Ȃ߁CeXg
 *		ȂD
 *	(C) CPUOnhsJnɃfBXpb`֎~tOωȂ
 *	(D) CPUOnhsJnɃ^XNO֎~tOωȂ
 *	(E) CPUOnh^[CPUbNtOɖ߂邱
 *		ICPUOnh烊^[łꍇ̂݃eXgD
 *	(F) CPUOnh^[ɊݗDx}XNɖ߂邱
 *		ICPUOnh烊^[łꍇ̂݃eXgD
 *	(G) CPUOnh^[ɃfBXpb`֎~tOωȂ
 *		ICPUOnh烊^[łꍇ̂݃eXgD
 *	(H) CPUOnh^[Ƀ^XNO֎~tOωȂ
 *		ICPUOnh烊^[łꍇ̂݃eXgD
 *	(I) xsns_xpntrueԂ
 *	(J) xsns_dpntrueԂ
 *
 * ygp\[Xz
 *
 *	TASK1: TA_ACTCDxC^XNO[`o^
 *	CPUEXC1: TA_NULL
 *
 * yeXgV[PXz
 *
 *	== TASK1iDxj==
 *	1:	Ԃ̃`FbN
 *		dis_dsp()
 *		ena_tex()
 *		loc_cpu()
 *	2:	Ԃ̃`FbN
 *		RAISE_CPU_EXCEPTION
 *	== CPUEXC1 ==
 *	3:	Ԃ̃`FbN				... (A)(C)(D)
 *		xsns_xpn() == true			... (I)
 *		xsns_dpn() == true			... (J)
 *	4:	CPUOnh烊^[łȂꍇ́CŏI
 *	4:	^[
 *	== TASK1ij==
 *	5:	Ԃ̃`FbN				... (E)(F)(G)(H)
 *	6:	eXgI
 */

#include <kernel.h>
#include <t_syslog.h>
#include "kernel_cfg.h"
#include "test_lib.h"
#include "test_cpuexc.h"

void
task1(intptr_t exinf)
{
	ER		ercd;

	check_point(1);
	check_state(false, false, TIPM_ENAALL, false, false, true);
	ercd = dis_dsp();
	check_ercd(ercd, E_OK);
	ercd = ena_tex();
	check_ercd(ercd, E_OK);
	ercd = loc_cpu();
	check_ercd(ercd, E_OK);

	check_point(2);
	check_state(false, true, TIPM_ENAALL, true, true, false);
	RAISE_CPU_EXCEPTION;

	check_point(5);
	check_state(false, true, TIPM_ENAALL, true, true, false);

	check_finish(6);
}

void
tex_task1(TEXPTN texptn, intptr_t exinf)
{
	check_point(0);
}

void
task2(intptr_t exinf)
{
	check_point(0);
}

void
alarm1_handler(intptr_t exinf)
{
	check_point(0);
}

void
cpuexc_handler(void *p_excinf)
{
	check_point(3);
	check_state_i(true, true, true, true, false);
	check_assert(xsns_xpn(p_excinf) == true);
	check_assert(xsns_dpn(p_excinf) == true);

#ifdef CANNOT_RETURN_CPUEXC
	check_finish(4);
#endif /* CANNOT_RETURN_CPUEXC */

	check_point(4);
}
